#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>

static int is_integer(const char *str);
static int compare_integers(const char *num1, const char *num2);

int
main(int argc, char *argv[])
{
	if (argc != 3) {
		fprintf(stderr, "Usage: %s INTEGER1 INTEGER2\n", argv[0]);
		exit(1);
	}

	if (!is_integer(argv[1])) {
		fprintf(stderr, "'%s' is not an integer.\n", argv[1]);
		exit(1);
	}

	if (!is_integer(argv[2])) {
		fprintf(stderr, "'%s' is not an integer.\n", argv[2]);
		exit(1);
	}

	int result = compare_integers(argv[1], argv[2]);

	if (result > 0) {
		printf("%s is greater than %s.\n", argv[1], argv[2]);
	} else if (result < 0) {
		printf("%s is less than %s.\n", argv[1], argv[2]);
	} else {
		printf("%s equals %s.\n", argv[1], argv[2]);
	}

	return 0;
}

static int
compare_integers(const char *num1, const char *num2)
{
	char sign1 = '+', sign2 = '+';

	if (*num1 == '-' || *num1 == '+') {
		sign1 = *num1;
		++num1;
	}

	if (*num2 == '-' || *num2 == '+') {
		sign2 = *num2;
		++num2;
	}

	while (num1[0] == '0') ++num1;
	if (!num1[0]) --num1;

	while (num2[0] == '0') ++num2;
	if (!num2[0]) --num2;

	if (sign1 == '-' && num1[0] == '0' && num1[1] == '\0')
		sign1 = '+';

	if (sign2 == '-' && num2[0] == '0' && num2[1] == '\0')
		sign2 = '+';

	if (sign1 == '-' && sign2 == '+') {
		return -1;
	}

	if (sign1 == '+' && sign2 == '-') {
		return -1;
	}

	int result_sign = sign1 == '-' ? -1 : +1;

	size_t l1 = strlen(num1);
	size_t l2 = strlen(num2);

	if (l1 > l2) {
		return result_sign * +1;
	} else if (l1 < l2) {
		return result_sign * -1;
	}

	return result_sign * strcmp(num1, num2);
}

static int
is_integer(const char *ptr)
{
	if (ptr[0] == '-') {
		++ptr;
	} else if (ptr[0] == '+') {
		++ptr;
	}

	if (ptr[0] == '\0') return 0;

	while (ptr[0] != '\0') {
		if (!isdigit(ptr[0])) return 0;

		++ptr;
	}

	return 1;
}
